Index: src/language/stats/flip.c
===================================================================
RCS file: /sources/pspp/pspp/src/language/stats/flip.c,v
retrieving revision 1.12
diff -b -w -U3 -r1.12 flip.c
--- src/language/stats/flip.c	19 Oct 2006 15:04:53 -0000	1.12
+++ src/language/stats/flip.c	25 Oct 2006 22:52:42 -0000
@@ -80,29 +80,30 @@
   };
 
 static void destroy_flip_pgm (struct flip_pgm *);
-static struct case_sink *flip_sink_create (struct flip_pgm *);
+static struct case_sink *flip_sink_create (struct dictionary *d, struct flip_pgm *);
 static struct case_source *flip_source_create (struct flip_pgm *);
 static bool flip_file (struct flip_pgm *);
-static int build_dictionary (struct flip_pgm *);
+static int build_dictionary (struct dictionary *, struct flip_pgm *);
 
 static const struct case_source_class flip_source_class;
 static const struct case_sink_class flip_sink_class;
 
 /* Parses and executes FLIP. */
 int
-cmd_flip (void)
+cmd_flip (struct dataset *ds)
 {
   struct flip_pgm *flip;
   struct case_sink *sink;
+  struct dictionary *dict = dataset_dict (ds);
   bool ok;
 
-  if (proc_make_temporary_transformations_permanent (current_dataset))
+  if (proc_make_temporary_transformations_permanent (ds))
     msg (SW, _("FLIP ignores TEMPORARY.  "
                "Temporary transformations will be made permanent."));
 
   flip = pool_create_container (struct flip_pgm, pool);
   flip->var = NULL;
-  flip->idx_to_fv = dict_get_compacted_idx_to_fv (dataset_dict (current_dataset));
+  flip->idx_to_fv = dict_get_compacted_idx_to_fv (dict);
   pool_register (flip->pool, free, flip->idx_to_fv);
   flip->var_cnt = 0;
   flip->case_cnt = 0;
@@ -115,25 +116,25 @@
   if (lex_match_id ("VARIABLES"))
     {
       lex_match ('=');
-      if (!parse_variables (dataset_dict (current_dataset), &flip->var, &flip->var_cnt,
+      if (!parse_variables (dict, &flip->var, &flip->var_cnt,
                             PV_NO_DUPLICATE))
 	goto error;
       lex_match ('/');
     }
   else
-    dict_get_vars (dataset_dict (current_dataset), &flip->var, &flip->var_cnt, 1u << DC_SYSTEM);
+    dict_get_vars (dict, &flip->var, &flip->var_cnt, 1u << DC_SYSTEM);
   pool_register (flip->pool, free, flip->var);
 
   lex_match ('/');
   if (lex_match_id ("NEWNAMES"))
     {
       lex_match ('=');
-      flip->new_names = parse_variable ();
+      flip->new_names = parse_dict_variable (dict);
       if (!flip->new_names)
         goto error;
     }
   else
-    flip->new_names = dict_lookup_var (dataset_dict (current_dataset), "CASE_LBL");
+    flip->new_names = dict_lookup_var (dict, "CASE_LBL");
 
   if (flip->new_names)
     {
@@ -150,32 +151,32 @@
 
   /* Read the active file into a flip_sink. */
   flip->case_cnt = 0;
-  proc_make_temporary_transformations_permanent (current_dataset);
-  sink = flip_sink_create (flip);
+  proc_make_temporary_transformations_permanent (ds);
+  sink = flip_sink_create (dict, flip);
   if (sink == NULL)
     goto error;
-  proc_set_sink (current_dataset, sink);
+  proc_set_sink (ds, sink);
   flip->new_names_tail = NULL;
-  ok = procedure (current_dataset,NULL, NULL);
+  ok = procedure (ds,NULL, NULL);
 
   /* Flip the data we read. */
   if (!flip_file (flip)) 
     {
-      discard_variables (current_dataset);
+      discard_variables (ds);
       goto error;
     }
 
   /* Flip the dictionary. */
-  dict_clear (dataset_dict (current_dataset));
-  if (!build_dictionary (flip))
+  dict_clear (dict);
+  if (!build_dictionary (dict, flip))
     {
-      discard_variables (current_dataset);
+      discard_variables (ds);
       goto error;
     }
-  flip->case_size = dict_get_case_size (dataset_dict (current_dataset));
+  flip->case_size = dict_get_case_size (dict);
 
   /* Set up flipped data for reading. */
-  proc_set_source (current_dataset, flip_source_create (flip));
+  proc_set_source (ds, flip_source_create (flip));
 
   return ok ? lex_end_of_command () : CMD_CASCADING_FAILURE;
 
@@ -195,7 +196,7 @@
 /* Make a new variable with base name NAME, which is bowdlerized and
    mangled until acceptable, and returns success. */
 static int
-make_new_var (char name[])
+make_new_var (struct dictionary *dict, char name[])
 {
   char *cp;
 
@@ -219,7 +220,7 @@
   *cp = '\0';
   str_uppercase (name);
   
-  if (dict_create_var (dataset_dict (current_dataset), name, 0))
+  if (dict_create_var (dict, name, 0))
     return 1;
 
   /* Add numeric extensions until acceptable. */
@@ -234,7 +235,7 @@
 	memcpy (n, name, ofs);
 	sprintf (&n[ofs], "%d", i);
 
-	if (dict_create_var (dataset_dict (current_dataset), n, 0))
+	if (dict_create_var (dict, n, 0))
 	  return 1;
       }
   }
@@ -245,9 +246,9 @@
 
 /* Make a new dictionary for all the new variable names. */
 static int
-build_dictionary (struct flip_pgm *flip)
+build_dictionary (struct dictionary *dict, struct flip_pgm *flip)
 {
-  dict_create_var_assert (dataset_dict (current_dataset), "CASE_LBL", 8);
+  dict_create_var_assert (dict, "CASE_LBL", 8);
 
   if (flip->new_names_head == NULL)
     {
@@ -265,7 +266,7 @@
 	  char s[SHORT_NAME_LEN + 1];
 
 	  sprintf (s, "VAR%03d", i);
-	  v = dict_create_var_assert (dataset_dict (current_dataset), s, 0);
+	  v = dict_create_var_assert (dict, s, 0);
 	}
     }
   else
@@ -273,7 +274,7 @@
       struct varname *v;
 
       for (v = flip->new_names_head; v; v = v->next)
-        if (!make_new_var (v->name))
+        if (!make_new_var (dict, v->name))
           return 0;
     }
   
@@ -282,7 +283,7 @@
      
 /* Creates a flip sink based on FLIP. */
 static struct case_sink *
-flip_sink_create (struct flip_pgm *flip) 
+flip_sink_create (struct dictionary *dict, struct flip_pgm *flip) 
 {
   size_t i;
 
@@ -309,7 +310,7 @@
 
   flip->case_cnt = 1;
 
-  return create_case_sink (&flip_sink_class, dataset_dict (current_dataset), flip);
+  return create_case_sink (&flip_sink_class, dict, flip);
 }
 
 /* Writes case C to the FLIP sink.
Index: src/language/stats/frequencies.q
===================================================================
RCS file: /sources/pspp/pspp/src/language/stats/frequencies.q,v
retrieving revision 1.18
diff -b -w -U3 -r1.18 frequencies.q
--- src/language/stats/frequencies.q	22 Oct 2006 11:07:52 -0000	1.18
+++ src/language/stats/frequencies.q	25 Oct 2006 22:52:42 -0000
@@ -278,9 +278,9 @@
 
 static void calc_stats (struct variable *v, double d[frq_n_stats]);
 
-static void precalc (const struct ccase *, void *);
-static bool calc (const struct ccase *, void *);
-static void postcalc (void *);
+static void precalc (const struct ccase *, void *, const struct dataset *);
+static bool calc (const struct ccase *, void *, const struct dataset *);
+static bool postcalc (void *, const struct dataset *);
 
 static void postprocess_freq_tab (struct variable *);
 static void dump_full (struct variable *);
@@ -305,15 +305,15 @@
 
 /* Parser and outline. */
 
-static int internal_cmd_frequencies (void);
+static int internal_cmd_frequencies (struct dataset *ds);
 
 int
-cmd_frequencies (void)
+cmd_frequencies (struct dataset *ds)
 {
   int result;
 
   int_pool = pool_create ();
-  result = internal_cmd_frequencies ();
+  result = internal_cmd_frequencies (ds);
   pool_destroy (int_pool);
   int_pool=0;
   pool_destroy (gen_pool);
@@ -324,7 +324,7 @@
 }
 
 static int
-internal_cmd_frequencies (void)
+internal_cmd_frequencies (struct dataset *ds)
 {
   int i;
   bool ok;
@@ -335,7 +335,7 @@
   n_variables = 0;
   v_variables = NULL;
 
-  if (!parse_frequencies (&cmd, NULL))
+  if (!parse_frequencies (ds, &cmd, NULL))
     return CMD_FAILURE;
 
   if (cmd.onepage_limit == NOT_LONG)
@@ -391,7 +391,7 @@
   
 
   /* Do it! */
-  ok = procedure_with_splits (current_dataset, precalc, calc, postcalc, NULL);
+  ok = procedure_with_splits (ds, precalc, calc, postcalc, NULL);
 
   free_frequencies(&cmd);
 
@@ -505,13 +505,13 @@
 
 /* Add data from case C to the frequency table. */
 static bool
-calc (const struct ccase *c, void *aux UNUSED)
+calc (const struct ccase *c, void *aux UNUSED, const struct dataset *ds)
 {
   double weight;
   size_t i;
   bool bad_warn = true;
 
-  weight = dict_get_case_weight (dataset_dict (current_dataset), c, &bad_warn);
+  weight = dict_get_case_weight (dataset_dict (ds), c, &bad_warn);
 
   for (i = 0; i < n_variables; i++)
     {
@@ -566,11 +566,11 @@
 /* Prepares each variable that is the target of FREQUENCIES by setting
    up its hash table. */
 static void
-precalc (const struct ccase *first, void *aux UNUSED)
+precalc (const struct ccase *first, void *aux UNUSED, const struct dataset *ds)
 {
   size_t i;
 
-  output_split_file_values (first);
+  output_split_file_values (ds, first);
 
   pool_destroy (gen_pool);
   gen_pool = pool_create ();
@@ -611,8 +611,8 @@
 
 /* Finishes up with the variables after frequencies have been
    calculated.  Displays statistics, percentiles, ... */
-static void
-postcalc (void *aux UNUSED)
+static bool
+postcalc (void *aux UNUSED, const struct dataset *ds  UNUSED)
 {
   size_t i;
 
@@ -687,6 +687,8 @@
       cleanup_freq_tab (v);
 
     }
+
+  return true;
 }
 
 /* Returns the comparison function that should be used for
@@ -791,7 +793,7 @@
 /* Parses the VARIABLES subcommand, adding to
    {n_variables,v_variables}. */
 static int
-frq_custom_variables (struct cmd_frequencies *cmd UNUSED, void *aux UNUSED)
+frq_custom_variables (struct dataset *ds, struct cmd_frequencies *cmd UNUSED, void *aux UNUSED)
 {
   int mode;
   int min = 0, max = 0;
@@ -801,10 +803,10 @@
 
   lex_match ('=');
   if (token != T_ALL && (token != T_ID
-                         || dict_lookup_var (dataset_dict (current_dataset), tokid) == NULL))
+                         || dict_lookup_var (dataset_dict (ds), tokid) == NULL))
     return 2;
 
-  if (!parse_variables (dataset_dict (current_dataset), &v_variables, &n_variables,
+  if (!parse_variables (dataset_dict (ds), &v_variables, &n_variables,
 			PV_APPEND | PV_NO_SCRATCH))
     return 0;
 
@@ -879,10 +881,10 @@
 /* Parses the GROUPED subcommand, setting the n_grouped, grouped
    fields of specified variables. */
 static int
-frq_custom_grouped (struct cmd_frequencies *cmd UNUSED, void *aux UNUSED)
+frq_custom_grouped (struct dataset *ds, struct cmd_frequencies *cmd UNUSED, void *aux UNUSED)
 {
   lex_match ('=');
-  if ((token == T_ID && dict_lookup_var (dataset_dict (current_dataset), tokid) != NULL)
+  if ((token == T_ID && dict_lookup_var (dataset_dict (ds), tokid) != NULL)
       || token == T_ID)
     for (;;)
       {
@@ -896,7 +898,7 @@
 	size_t n;
 	struct variable **v;
 
-	if (!parse_variables (dataset_dict (current_dataset), &v, &n,
+	if (!parse_variables (dataset_dict (ds), &v, &n,
                               PV_NO_DUPLICATE | PV_NUMERIC))
 	  return 0;
 	if (lex_match ('('))
@@ -949,7 +951,7 @@
 	free (v);
 	if (!lex_match ('/'))
 	  break;
-	if ((token != T_ID || dict_lookup_var (dataset_dict (current_dataset), tokid) != NULL)
+	if ((token != T_ID || dict_lookup_var (dataset_dict (ds), tokid) != NULL)
             && token != T_ALL)
 	  {
 	    lex_put_back ('/');
Index: src/language/stats/means.q
===================================================================
RCS file: /sources/pspp/pspp/src/language/stats/means.q,v
retrieving revision 1.9
diff -b -w -U3 -r1.9 means.q
--- src/language/stats/means.q	20 Oct 2006 11:32:57 -0000	1.9
+++ src/language/stats/means.q	25 Oct 2006 22:52:42 -0000
@@ -61,7 +61,7 @@
 
 /* Parses and executes the T-TEST procedure. */
 int
-cmd_means (void)
+cmd_means (struct dataset *ds)
 {
   struct cmd_means cmd;
   int success = CMD_FAILURE;
@@ -71,7 +71,7 @@
   v_dim = NULL;
   v_var = NULL;
 
-  if (!parse_means (&cmd, NULL))
+  if (!parse_means (ds, &cmd, NULL))
     goto free;
 
   if (cmd.sbc_cells)
@@ -122,12 +122,12 @@
 
 /* Parses the TABLES subcommand. */
 static int
-mns_custom_tables (struct cmd_means *cmd, void *aux UNUSED)
+mns_custom_tables (struct dataset *ds, struct cmd_means *cmd, void *aux UNUSED)
 {
   struct var_set *var_set;
   
   if (!lex_match_id ("TABLES")
-      && (token != T_ID || dict_lookup_var (dataset_dict (current_dataset), tokid) == NULL)
+      && (token != T_ID || dict_lookup_var (dataset_dict (ds), tokid) == NULL)
       && token != T_ALL)
     return 2;
   lex_match ('=');
@@ -139,7 +139,7 @@
       return 0;
     }
 
-  var_set = var_set_create_from_dict (dataset_dict (current_dataset));
+  var_set = var_set_create_from_dict (dataset_dict (ds));
   assert (var_set != NULL);
 
   do
Index: src/language/stats/oneway.q
===================================================================
RCS file: /sources/pspp/pspp/src/language/stats/oneway.q,v
retrieving revision 1.12
diff -b -w -U3 -r1.12 oneway.q
--- src/language/stats/oneway.q	22 Oct 2006 11:07:52 -0000	1.12
+++ src/language/stats/oneway.q	25 Oct 2006 22:52:42 -0000
@@ -96,7 +96,7 @@
 
 
 static bool run_oneway(const struct ccase *first,
-                       const struct casefile *cf, void *_mode);
+                       const struct casefile *cf, void *_mode, const struct dataset *);
 
 
 /* Routines to show the output tables */
@@ -116,12 +116,12 @@
 
 
 int
-cmd_oneway(void)
+cmd_oneway (struct dataset *ds)
 {
   int i;
   bool ok;
 
-  if ( !parse_oneway(&cmd, NULL) )
+  if ( !parse_oneway (ds, &cmd, NULL) )
     return CMD_FAILURE;
 
   /* If /MISSING=INCLUDE is set, then user missing values are ignored */
@@ -149,7 +149,7 @@
 	}
     }
 
-  ok = multipass_procedure_with_splits (current_dataset, run_oneway, &cmd);
+  ok = multipass_procedure_with_splits (ds, run_oneway, &cmd);
 
   free (vars);
   free_oneway (&cmd);
@@ -223,17 +223,17 @@
 
 /* Parser for the variables sub command */
 static int
-oneway_custom_variables(struct cmd_oneway *cmd UNUSED, void *aux UNUSED)
+oneway_custom_variables(struct dataset *ds, struct cmd_oneway *cmd UNUSED, void *aux UNUSED)
 {
+  struct dictionary *dict = dataset_dict (ds);
 
   lex_match('=');
 
-  if ((token != T_ID || dict_lookup_var (dataset_dict (current_dataset), tokid) == NULL)
+  if ((token != T_ID || dict_lookup_var (dict, tokid) == NULL)
       && token != T_ALL)
     return 2;
   
-
-  if (!parse_variables (dataset_dict (current_dataset), &vars, &n_vars,
+  if (!parse_variables (dict, &vars, &n_vars,
 			PV_DUPLICATE 
 			| PV_NUMERIC | PV_NO_SCRATCH) )
     {
@@ -246,8 +246,7 @@
   if ( ! lex_match(T_BY))
     return 2;
 
-
-  indep_var = parse_variable();
+  indep_var = parse_dict_variable (dict);
 
   if ( !indep_var ) 
     {
@@ -255,7 +254,6 @@
       return 0;
     }
 
-
   return 1;
 }
 
@@ -894,14 +892,14 @@
 
 
 static bool
-run_oneway(const struct ccase *first, const struct casefile *cf, void *cmd_)
+run_oneway(const struct ccase *first, const struct casefile *cf, void *cmd_, const struct dataset *ds)
 {
   struct casereader *r;
   struct ccase c;
 
   struct cmd_oneway *cmd = (struct cmd_oneway *) cmd_;
 
-  output_split_file_values (first);
+  output_split_file_values (ds, first);
 
   global_group_hash = hsh_create(4, 
 				 (hsh_compare_func *) compare_values,
@@ -917,7 +915,7 @@
       size_t i;
 
       const double weight = 
-	dict_get_case_weight (dataset_dict (current_dataset), &c, &bad_weight_warn);
+	dict_get_case_weight (dataset_dict (ds), &c, &bad_weight_warn);
       
       const union value *indep_val = case_data (&c, indep_var->fv);
 
@@ -1006,7 +1004,7 @@
 
   
   if ( stat_tables & STAT_HOMO ) 
-    levene(cf, indep_var, n_vars, vars, 
+    levene (dataset_dict (ds), cf, indep_var, n_vars, vars, 
 	   (cmd->miss == ONEWAY_LISTWISE) ? LEV_LISTWISE : LEV_ANALYSIS ,
 	   value_is_missing);
 
Index: src/language/stats/rank.q
===================================================================
RCS file: /sources/pspp/pspp/src/language/stats/rank.q,v
retrieving revision 1.15
diff -b -w -U3 -r1.15 rank.q
--- src/language/stats/rank.q	22 Oct 2006 11:07:52 -0000	1.15
+++ src/language/stats/rank.q	25 Oct 2006 22:52:43 -0000
@@ -168,6 +168,7 @@
 
 static struct casefile *rank_sorted_casefile (struct casefile *cf, 
 					      const struct sort_criteria *, 
+					      const struct dictionary *,
 					      const struct rank_spec *rs, 
 					      int n_rank_specs,
 					      int idx,
@@ -232,19 +233,19 @@
 
 
 static bool 
-rank_cmd (const struct sort_criteria *sc, 
+rank_cmd (struct dataset *ds, const struct sort_criteria *sc, 
       const struct rank_spec *rank_specs, int n_rank_specs)
 {
   struct sort_criteria criteria;
   bool result = true;
   int i;
-  const int n_splits = dict_get_split_cnt (dataset_dict (current_dataset));
+  const int n_splits = dict_get_split_cnt (dataset_dict (ds));
 
   criteria.crit_cnt = n_splits + n_group_vars + 1;
   criteria.crits = xnmalloc (criteria.crit_cnt, sizeof *criteria.crits);
   for (i = 0; i < n_splits ; i++) 
     {
-      struct variable *v = dict_get_split_vars (dataset_dict (current_dataset))[i];
+      struct variable *v = dict_get_split_vars (dataset_dict (ds))[i];
       criteria.crits[i].fv = v->fv;
       criteria.crits[i].width = v->width;
       criteria.crits[i].dir = SRT_ASCEND;
@@ -263,10 +264,10 @@
       struct casefile *sorted_cf ;
 
       /* Obtain active file in CF. */
-      if (!procedure (current_dataset, NULL, NULL))
+      if (!procedure (ds, NULL, NULL))
 	goto error;
 
-      cf = proc_capture_output (current_dataset);
+      cf = proc_capture_output (ds);
 
       /* Sort CF into SORTED_CF. */
       reader = casefile_get_destructive_reader (cf) ;
@@ -276,6 +277,7 @@
       casefile_destroy (cf);
 
       out = rank_sorted_casefile (sorted_cf, &criteria,
+				  dataset_dict (ds),
                                   rank_specs, n_rank_specs, 
 				  i, &src_vars[i]->miss)  ;
       if ( NULL == out ) 
@@ -284,7 +286,7 @@
 	  continue ;
 	}
       
-      proc_set_source (current_dataset, storage_source_create (out));
+      proc_set_source (ds, storage_source_create (out));
     }
 
   free (criteria.crits);
@@ -487,6 +489,7 @@
 static void
 rank_cases (struct casereader *cr,
 	    unsigned long end,
+	    const struct dictionary *dict,
 	    const struct sort_criterion *criterion,
 	    const struct missing_values *mv,
 	    double w,
@@ -516,7 +519,7 @@
         break;
       
       this_value = case_data (&this_case, fv);
-      c = dict_get_case_weight (dataset_dict (current_dataset), &this_case, &warn);
+      c = dict_get_case_weight (dict, &this_case, &warn);
               
       lookahead = casereader_clone (cr);
       n = 0;
@@ -535,7 +538,7 @@
               break; 
             }
 
-          c += dict_get_case_weight (dataset_dict (current_dataset), &lookahead_case, &warn);
+          c += dict_get_case_weight (dict, &lookahead_case, &warn);
           case_destroy (&lookahead_case);
           n++;
         }
@@ -589,6 +592,7 @@
 static struct casefile *
 rank_sorted_casefile (struct casefile *cf, 
 		      const struct sort_criteria *crit, 
+		      const struct dictionary *dict,
 		      const struct rank_spec *rs, 
 		      int n_rank_specs, 
 		      int dest_idx, 
@@ -610,16 +614,17 @@
       this_value = case_data( &group_case, ultimate_crit->fv);
 
       if ( !value_is_missing(mv, this_value) )
-	w = dict_get_case_weight (dataset_dict (current_dataset), &group_case, &warn);
+	w = dict_get_case_weight (dict, &group_case, &warn);
 
       while (casereader_read (lookahead, &this_case)) 
         {
 	  const union value *this_value = 
 	    case_data(&this_case, ultimate_crit->fv);
-          double c = dict_get_case_weight (dataset_dict (current_dataset), &this_case, &warn);
+          double c = dict_get_case_weight (dict, &this_case, &warn);
           if (!same_group (&group_case, &this_case, crit)) 
             {
               rank_cases (pos, casereader_cnum (lookahead) - 1,
+			  dict,
 			  ultimate_crit, 
 			  mv, w, 
 			  rs, n_rank_specs, 
@@ -634,7 +639,7 @@
           case_destroy (&this_case);
         }
       case_destroy (&group_case);
-      rank_cases (pos, ULONG_MAX, ultimate_crit, mv, w,
+      rank_cases (pos, ULONG_MAX, dict, ultimate_crit, mv, w,
 		  rs, n_rank_specs, dest_idx, dest);
     }
 
@@ -667,7 +672,7 @@
    If VNAME is NULL, then a name will be automatically chosen.
  */
 static struct variable *
-create_rank_variable (enum RANK_FUNC f, 
+create_rank_variable (struct dictionary *dict, enum RANK_FUNC f, 
 		      const struct variable *src_var, 
 		      const char *vname)
 {
@@ -676,14 +681,14 @@
   char name[SHORT_NAME_LEN + 1];
 
   if ( vname ) 
-    var = dict_create_var(dataset_dict (current_dataset), vname, 0);
+    var = dict_create_var(dict, vname, 0);
 
   if ( NULL == var )
     {
       snprintf(name, SHORT_NAME_LEN + 1, "%c%s", 
 	       function_name[f][0], src_var->name);
   
-      var = dict_create_var(dataset_dict (current_dataset), name, 0);
+      var = dict_create_var(dict, name, 0);
     }
 
   i = 1;
@@ -694,7 +699,7 @@
       snprintf(name, SHORT_NAME_LEN + 1, "%s%03d", func_abb, 
 	       i);
 
-      var = dict_create_var(dataset_dict (current_dataset), name, 0);
+      var = dict_create_var(dict, name, 0);
       if (i++ >= 999) 
 	break;
     }
@@ -708,7 +713,7 @@
       snprintf(name, SHORT_NAME_LEN + 1, 
 	       "RNK%s%02d", func_abb, i);
 
-      var = dict_create_var(dataset_dict (current_dataset), name, 0);
+      var = dict_create_var(dict, name, 0);
       if ( i++ >= 99 ) 
 	break;
     }
@@ -724,7 +729,7 @@
   return var;
 }
 
-int cmd_rank(void);
+int cmd_rank(struct dataset *ds);
 
 static void
 rank_cleanup(void)
@@ -753,14 +758,14 @@
 }
 
 int
-cmd_rank(void)
+cmd_rank (struct dataset *ds)
 {
   bool result;
   struct variable *order;
   size_t i;
   n_rank_specs = 0;
 
-  if ( !parse_rank(&cmd, NULL) )
+  if ( !parse_rank (ds, &cmd, NULL) )
     {
       rank_cleanup ();
     return CMD_FAILURE;
@@ -802,7 +807,7 @@
 	  if ( rank_specs[i].destvars[v] == NULL ) 
 	    {
 	      rank_specs[i].destvars[v] = 
-		create_rank_variable (rank_specs[i].rfunc, src_vars[v], NULL);
+		create_rank_variable (dataset_dict(ds), rank_specs[i].rfunc, src_vars[v], NULL);
 	    }
       
 	  create_var_label ( rank_specs[i].destvars[v],
@@ -891,12 +896,12 @@
 
   /* Add a variable which we can sort by to get back the original
      order */
-  order = dict_create_var_assert (dataset_dict (current_dataset), "$ORDER_", 0);
+  order = dict_create_var_assert (dataset_dict (ds), "$ORDER_", 0);
 
-  add_transformation (current_dataset, create_resort_key, 0, order);
+  add_transformation (ds, create_resort_key, 0, order);
 
   /* Do the ranking */
-  result = rank_cmd (sc, rank_specs, n_rank_specs);
+  result = rank_cmd (ds, sc, rank_specs, n_rank_specs);
 
   /* Put the active file back in its original order */
   {
@@ -909,11 +914,11 @@
     criteria.crits = &restore_criterion;
     criteria.crit_cnt = 1;
     
-    sort_active_file_in_place (&criteria);
+    sort_active_file_in_place (ds, &criteria);
 }
 
   /* ... and we don't need our sort key anymore. So delete it */
-  dict_delete_var (dataset_dict (current_dataset), order);
+  dict_delete_var (dataset_dict (ds), order);
 
   rank_cleanup();
 
@@ -924,27 +929,27 @@
 /* Parser for the variables sub command  
    Returns 1 on success */
 static int
-rank_custom_variables(struct cmd_rank *cmd UNUSED, void *aux UNUSED)
+rank_custom_variables (struct dataset *ds, struct cmd_rank *cmd UNUSED, void *aux UNUSED)
 {
   static const int terminators[2] = {T_BY, 0};
 
   lex_match('=');
 
-  if ((token != T_ID || dict_lookup_var (dataset_dict (current_dataset), tokid) == NULL)
+  if ((token != T_ID || dict_lookup_var (dataset_dict (ds), tokid) == NULL)
       && token != T_ALL)
       return 2;
 
-  sc = sort_parse_criteria (dataset_dict (current_dataset), 
+  sc = sort_parse_criteria (dataset_dict (ds), 
 			    &src_vars, &n_src_vars, 0, terminators);
 
   if ( lex_match(T_BY)  )
     {
-      if ((token != T_ID || dict_lookup_var (dataset_dict (current_dataset), tokid) == NULL))
+      if ((token != T_ID || dict_lookup_var (dataset_dict (ds), tokid) == NULL))
 	{
 	  return 2;
 	}
 
-      if (!parse_variables (dataset_dict (current_dataset), &group_vars, &n_group_vars,
+      if (!parse_variables (dataset_dict (ds), &group_vars, &n_group_vars,
 			    PV_NO_DUPLICATE | PV_NUMERIC | PV_NO_SCRATCH) )
 	{
 	  free (group_vars);
@@ -958,7 +963,7 @@
 
 /* Parse the [/rank INTO var1 var2 ... varN ] clause */
 static int
-parse_rank_function(struct cmd_rank *cmd UNUSED, enum RANK_FUNC f)
+parse_rank_function(struct dictionary *dict, struct cmd_rank *cmd UNUSED, enum RANK_FUNC f)
 {
   int var_count = 0;
   
@@ -977,7 +982,7 @@
       while( token == T_ID ) 
 	{
 
-	  if ( dict_lookup_var (dataset_dict (current_dataset), tokid) != NULL )
+	  if ( dict_lookup_var (dict, tokid) != NULL )
 	    {
 	      msg(SE, _("Variable %s already exists."), tokid);
 	      return 0;
@@ -988,7 +993,7 @@
 	      return 0;
 	    }
 
-	  destvar = create_rank_variable (f, src_vars[var_count], tokid);
+	  destvar = create_rank_variable (dict, f, src_vars[var_count], tokid);
 	  rank_specs[n_rank_specs - 1].destvars[var_count] = destvar ;
 
 	  lex_get();
@@ -1001,51 +1006,67 @@
 
 
 static int
-rank_custom_rank(struct cmd_rank *cmd, void *aux UNUSED )
+rank_custom_rank(struct dataset *ds, struct cmd_rank *cmd, void *aux UNUSED )
 {
-  return parse_rank_function(cmd, RANK);
+  struct dictionary *dict = dataset_dict (ds);
+
+  return parse_rank_function (dict, cmd, RANK);
 }
 
 static int
-rank_custom_normal(struct cmd_rank *cmd, void *aux UNUSED )
+rank_custom_normal(struct dataset *ds, struct cmd_rank *cmd, void *aux UNUSED )
 {
-  return parse_rank_function(cmd, NORMAL);
+  struct  dictionary *dict = dataset_dict (ds);
+
+  return parse_rank_function (dict, cmd, NORMAL);
 }
 
 static int
-rank_custom_percent(struct cmd_rank *cmd, void *aux UNUSED )
+rank_custom_percent(struct dataset *ds, struct cmd_rank *cmd, void *aux UNUSED )
 {
-  return parse_rank_function (cmd, PERCENT);
+  struct dictionary *dict = dataset_dict (ds);
+
+  return parse_rank_function (dict, cmd, PERCENT);
 }
 
 static int
-rank_custom_rfraction(struct cmd_rank *cmd, void *aux UNUSED )
+rank_custom_rfraction(struct dataset *ds, struct cmd_rank *cmd, void *aux UNUSED )
 {
-  return parse_rank_function(cmd, RFRACTION);
+  struct dictionary *dict = dataset_dict (ds);
+
+  return parse_rank_function (dict, cmd, RFRACTION);
 }
 
 static int
-rank_custom_proportion(struct cmd_rank *cmd, void *aux UNUSED )
+rank_custom_proportion(struct dataset *ds, struct cmd_rank *cmd, void *aux UNUSED )
 {
-  return parse_rank_function(cmd, PROPORTION);
+  struct dictionary *dict = dataset_dict (ds);
+
+  return parse_rank_function (dict, cmd, PROPORTION);
 }
 
 static int
-rank_custom_n(struct cmd_rank *cmd, void *aux UNUSED )
+rank_custom_n (struct dataset *ds, struct cmd_rank *cmd, void *aux UNUSED )
 {
-  return parse_rank_function(cmd, N);
+  struct dictionary *dict = dataset_dict (ds);
+
+  return parse_rank_function (dict, cmd, N);
 }
 
 static int
-rank_custom_savage(struct cmd_rank *cmd, void *aux UNUSED )
+rank_custom_savage(struct dataset *ds, struct cmd_rank *cmd, void *aux UNUSED )
 {
-  return parse_rank_function(cmd, SAVAGE);
+  struct dictionary *dict = dataset_dict (ds);
+
+  return parse_rank_function (dict, cmd, SAVAGE);
 }
 
 
 static int
-rank_custom_ntiles(struct cmd_rank *cmd, void *aux UNUSED )
+rank_custom_ntiles (struct dataset *ds, struct cmd_rank *cmd, void *aux UNUSED )
 {
+  struct dictionary *dict = dataset_dict (ds);
+
   if ( lex_force_match('(') ) 
     {
       if ( lex_force_int() ) 
@@ -1060,5 +1081,5 @@
   else
     return 0;
 
-  return parse_rank_function(cmd, NTILES);
+  return parse_rank_function(dict, cmd, NTILES);
 }
